
var huntsman = require('huntsman');
var spider = huntsman.spider();

spider.extensions = [
  huntsman.extension( 'recurse', {
    pattern: {
      // skip certain files and stay on this domain
      filter: /www\.personalcapital\.com.*(?!\.(pdf|png|jpg|gif|zip))....$/
    }
  }),
  huntsman.extension( 'cheerio' ) // load cheerio extension
];

// follow pages which match this uri regex
spider.on( /www\.personalcapital\.com/, function ( err, res ){

  console.log( '=====', res.uri, '=====' );

  var $ = res.extension.cheerio;
  if( !$ ) return;

  $('h1').each( function( element ){ console.log( 'h1', $(this).text() ); });
  $('h2').each( function( element ){ console.log( 'h2', $(this).text() ); });
  $('h3').each( function( element ){ console.log( 'h3', $(this).text() ); });

});

spider.queue.add( 'http://www.personalcapital.com' );
spider.start();